This selector has one other selectors whose meaning it inverts.

It actually relies on NoneSelector for its implementation of the isSelected() method, but it adds a check to ensure there is only one other selector contained within.

author | Hans Lellelid <hans@xmpl.org> (Phing)
author | Bruce Atherton <bruce@callenish.com> (Ant)
package | phing.types.selectors
version | $Id$

### Methods

## Add a new selector into this container.

    appendSelector(\FileSelector $selector) : \the

Inherited

inherited_from | \BaseSelectorContainer::appendSelector()
inherited_from | \NoneSelector::appendSelector()

### Parameters

#### $selector

`\selector`

the new selector to add

### Returns

`\the`selector that was added

## Creates an exception that indicates the user has generated a loop of data types referencing each other.

    circularReference()

Inherited

inherited_from | \DataType::circularReference()
inherited_from | \BaseSelector::circularReference()
inherited_from | \BaseSelectorContainer::circularReference()
inherited_from | \NoneSelector::circularReference()

## add an "And" selector entry on the selector list

    createAnd()

Inherited

inherited_from | \BaseSelectorContainer::createAnd()
inherited_from | \NoneSelector::createAnd()

## add a contains selector entry on the selector list

    createContains()

Inherited

inherited_from | \BaseSelectorContainer::createContains()
inherited_from | \NoneSelector::createContains()

## add a contains selector entry on the selector list

    createContainsRegexp()

Inherited

inherited_from | \BaseSelectorContainer::createContainsRegexp()
inherited_from | \NoneSelector::createContainsRegexp()

## add an extended selector entry on the selector list

    createCustom()

Inherited

inherited_from | \BaseSelectorContainer::createCustom()
inherited_from | \NoneSelector::createCustom()

## add a selector date entry on the selector list

    createDate()

Inherited

inherited_from | \BaseSelectorContainer::createDate()
inherited_from | \NoneSelector::createDate()

## add a depends selector entry on the selector list

    createDepend()

Inherited

inherited_from | \BaseSelectorContainer::createDepend()
inherited_from | \NoneSelector::createDepend()

## add a depth selector entry on the selector list

    createDepth()

Inherited

inherited_from | \BaseSelectorContainer::createDepth()
inherited_from | \NoneSelector::createDepth()

## add a selector filename entry on the selector list

    createFilename()

Inherited

inherited_from | \BaseSelectorContainer::createFilename()
inherited_from | \NoneSelector::createFilename()

## add a majority selector entry on the selector list

    createMajority()

Inherited

inherited_from | \BaseSelectorContainer::createMajority()
inherited_from | \NoneSelector::createMajority()

## add a "None" selector entry on the selector list

    createNone()

Inherited

inherited_from | \BaseSelectorContainer::createNone()
inherited_from | \NoneSelector::createNone()

## add a "Not" selector entry on the selector list

    createNot()

Inherited

inherited_from | \BaseSelectorContainer::createNot()
inherited_from | \NoneSelector::createNot()

## add an "Or" selector entry on the selector list

    createOr()

Inherited

inherited_from | \BaseSelectorContainer::createOr()
inherited_from | \NoneSelector::createOr()

## add a present selector entry on the selector list

    createPresent()

Inherited

inherited_from | \BaseSelectorContainer::createPresent()
inherited_from | \NoneSelector::createPresent()

## add a "Select" selector entry on the selector list

    createSelector()

Inherited

inherited_from | \BaseSelectorContainer::createSelector()
inherited_from | \NoneSelector::createSelector()

## add a selector size entry on the selector list

    createSize()

Inherited

inherited_from | \BaseSelectorContainer::createSize()
inherited_from | \NoneSelector::createSize()

## add a type selector entry on the selector list

    createType()

Inherited

inherited_from | \BaseSelectorContainer::createType()
inherited_from | \NoneSelector::createType()

## Check to see whether any DataType we hold references to is included in the Stack (which holds all DataType instances that directly or indirectly reference this instance, including this instance itself).

    dieOnCircularReference($stk, \Project $p)

Inherited

If one is included, throw a BuildException created by circularReference

This implementation is appropriate only for a DataType that cannot hold other DataTypes as children.

The general contract of this method is that it shouldn't do anything if checked is true and set it to true on exit.

inherited_from | \DataType::dieOnCircularReference()
inherited_from | \BaseSelector::dieOnCircularReference()
inherited_from | \BaseSelectorContainer::dieOnCircularReference()
inherited_from | \NoneSelector::dieOnCircularReference()

### Parameters

#### $stk

#### $p

## Performs the check for circular references and returns the referenced object.

    getCheckedRef($requiredClass, $dataTypeName)

Inherited

inherited_from | \DataType::getCheckedRef()
inherited_from | \BaseSelector::getCheckedRef()
inherited_from | \BaseSelectorContainer::getCheckedRef()
inherited_from | \NoneSelector::getCheckedRef()

### Parameters

#### $requiredClass

#### $dataTypeName

## Return the description for the current data type.

    getDescription()

Inherited

inherited_from | \DataType::getDescription()
inherited_from | \BaseSelector::getDescription()
inherited_from | \BaseSelectorContainer::getDescription()
inherited_from | \NoneSelector::getDescription()

## Returns any error messages that have been set.

    getError() : \the

Inherited

inherited_from | \BaseSelector::getError()
inherited_from | \BaseSelectorContainer::getError()
inherited_from | \NoneSelector::getError()

### Returns

`\the`error condition

## Returns a reference to current project

    getProject() : \Project

Inherited

inherited_from | \ProjectComponent::getProject()
inherited_from | \DataType::getProject()
inherited_from | \BaseSelector::getProject()
inherited_from | \BaseSelectorContainer::getProject()
inherited_from | \NoneSelector::getProject()

### Returns

`\Project`Reference to current porject object

## Returns a copy of the selectors as an array.

    getSelectors(\Project $p) : \an

Inherited

inherited_from | \BaseSelectorContainer::getSelectors()
inherited_from | \NoneSelector::getSelectors()

### Parameters

#### $p

### Returns

`\an`array of selectors in this container

## Indicates whether there are any selectors here.

    hasSelectors() : \whether

Inherited

inherited_from | \BaseSelectorContainer::hasSelectors()
inherited_from | \NoneSelector::hasSelectors()

### Returns

`\whether`any selectors are in this container

## Has the refid attribute of this element been set?

    isReference()

Inherited

inherited_from | \DataType::isReference()
inherited_from | \BaseSelector::isReference()
inherited_from | \BaseSelectorContainer::isReference()
inherited_from | \NoneSelector::isReference()

## Returns true (the file is selected) only if all other selectors agree that the file should not be selected.

    isSelected(\PhingFile $basedir, \filename $filename, \PhingFile $file) : \whether

Inherited

If there is a problem with the setup of a selector, it can throw a BuildException to indicate the problem.

inherited_from | \NoneSelector::isSelected()

### Parameters

#### $basedir

`\basedir`

the base directory the scan is being done from

#### $filename

`\filename`

is the name of the file to check

#### $file

`\file`

is a java.io.File object for the filename that the selector can use

### Exceptions

`\BuildException` | if the selector was not configured correctly

### Returns

`\whether`the file should be selected or not

## Logs a message with the given priority.

    log(string $msg, integer $level)

Inherited

inherited_from | \ProjectComponent::log()
inherited_from | \DataType::log()
inherited_from | \BaseSelector::log()
inherited_from | \BaseSelectorContainer::log()
inherited_from | \NoneSelector::log()

### Parameters

#### $msg

`string`

The message to be logged.

#### $level

`integer`

The message's priority at this message should have

## Creates an exception that indicates that this XML element must not have child elements if the refid attribute is set.

    noChildrenAllowed()

Inherited

inherited_from | \DataType::noChildrenAllowed()
inherited_from | \BaseSelector::noChildrenAllowed()
inherited_from | \BaseSelectorContainer::noChildrenAllowed()
inherited_from | \NoneSelector::noChildrenAllowed()

## Template method being called when the data type has been parsed completely.

    parsingComplete() : void

Inherited

inherited_from | \DataType::parsingComplete()
inherited_from | \BaseSelector::parsingComplete()
inherited_from | \BaseSelectorContainer::parsingComplete()
inherited_from | \NoneSelector::parsingComplete()

## Gives the count of the number of selectors in this container

    selectorCount() : \the

Inherited

inherited_from | \BaseSelectorContainer::selectorCount()
inherited_from | \NoneSelector::selectorCount()

### Returns

`\the`number of selectors in this container

## Returns an array for accessing the set of selectors (not a copy).

    selectorElements() : \an

Inherited

inherited_from | \BaseSelectorContainer::selectorElements()
inherited_from | \NoneSelector::selectorElements()

### Returns

`\an`enumerator that goes through each of the selectors

## Sets a description of the current data type.

    setDescription($desc)

Inherited

It will be useful in commenting what we are doing.

inherited_from | \DataType::setDescription()
inherited_from | \BaseSelector::setDescription()
inherited_from | \BaseSelectorContainer::setDescription()
inherited_from | \NoneSelector::setDescription()

### Parameters

#### $desc

## Allows all selectors to indicate a setup error.

    setError(\msg $msg)

Inherited

Note that only the first error message is recorded.

inherited_from | \BaseSelector::setError()
inherited_from | \BaseSelectorContainer::setError()
inherited_from | \NoneSelector::setError()

### Parameters

#### $msg

`\msg`

The error message any BuildException should throw.

## References the project to the current component.

    setProject(\Project $project)

Inherited

inherited_from | \ProjectComponent::setProject()
inherited_from | \DataType::setProject()
inherited_from | \BaseSelector::setProject()
inherited_from | \BaseSelectorContainer::setProject()
inherited_from | \NoneSelector::setProject()

### Parameters

#### $project

`\Project`

The reference to the current project

## Set the value of the refid attribute.

    setRefid(\Reference $r) : void

Inherited

Subclasses may need to check whether any other attributes have been set as well or child elements have been created and thus override this method. if they do they must call parent::setRefid()

inherited_from | \DataType::setRefid()
inherited_from | \BaseSelector::setRefid()
inherited_from | \BaseSelectorContainer::setRefid()
inherited_from | \NoneSelector::setRefid()

### Parameters

#### $r

`\Reference`

## Convert the Selectors within this container to a string.

    toString() : \comma

This will just be a helper class for the subclasses that put their own name around the contents listed here.

### Returns

`\comma`separated list of Selectors contained in this one

## Creates an exception that indicates that refid has to be the only attribute if it is set.

    tooManyAttributes()

Inherited

inherited_from | \DataType::tooManyAttributes()
inherited_from | \BaseSelector::tooManyAttributes()
inherited_from | \BaseSelectorContainer::tooManyAttributes()
inherited_from | \NoneSelector::tooManyAttributes()

## <p>This implementation validates the container by calling verifySettings() and then validates each contained selector provided that the selector implements the validate interface.

    validate()

Inherited

Ordinarily, this will validate all the elements of a selector container even if the isSelected() method of some elements is never called. This has two effects:

- Validation will often occur twice.
- Since it is not required that selectors derive from BaseSelector, there could be selectors in the container whose error conditions are not detected if their isSelected() call is never made.

inherited_from | \BaseSelectorContainer::validate()
inherited_from | \NoneSelector::validate()

## Makes sure that there is only one entry, sets an error message if not.

    verifySettings()

So long as they call validate() from isSelected(), this will be called automatically (unless they override validate()).

Implementations should check for incorrect settings and call setError() as necessary.

### Properties

##

    $description

Inherited

inherited_from | \DataType::$$description
inherited_from | \BaseSelector::$$description
inherited_from | \BaseSelectorContainer::$$description
inherited_from | \NoneSelector::$$description

##

    $ref

Inherited

Type of Reference

inherited_from | \DataType::$$ref
inherited_from | \BaseSelector::$$ref
inherited_from | \BaseSelectorContainer::$$ref
inherited_from | \NoneSelector::$$ref

##

    $checked : boolean

Inherited

Subclasses are responsible for setting this value to false if we'd need to investigate this condition (usually because a child element has been added that is a subclass of DataType).

inherited_from | \DataType::$$checked
inherited_from | \BaseSelector::$$checked
inherited_from | \BaseSelectorContainer::$$checked
inherited_from | \NoneSelector::$$checked

##

    $project : \Project

Inherited

inherited_from | \ProjectComponent::$$project
inherited_from | \DataType::$$project
inherited_from | \BaseSelector::$$project
inherited_from | \BaseSelectorContainer::$$project
inherited_from | \NoneSelector::$$project

##

    $errmsg

Inherited

inherited_from | \BaseSelector::$$errmsg
inherited_from | \BaseSelectorContainer::$$errmsg
inherited_from | \NoneSelector::$$errmsg

##

    $selectorsList

Inherited

inherited_from | \BaseSelectorContainer::$$selectorsList
inherited_from | \NoneSelector::$$selectorsList